<?php
/* This script is a standalone file that will return location data from Maxmind.com using
GeopIP2 City @ https://www.maxmind.com/en/geoip2-precision-services
We have no affiliation with Maxmind other than to provide this web services code.
It has been tested on PHP version 5.2x with mySql v5.6x on an Apache server. There is no 
reason to believe it will not work on all versions, with PHP >= 5.

Records are stored locally for future queries for repeat IP addresses to reduce website 
latency and API cost. We have no plans on updating this script, so you should be knowledgeable 
enough to edit this code if required in the future. 

More information can be found at http://dev.maxmind.com/geoip/geoip2/web-services/
*/
/**
 * @author     Click Precision® https://clickprecision.com/
 *
 * @copyright  Copyright (C) 2015 Click Precision®, LLC. All rights reserved.
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */


//////////////////// MYSQLI CONFIGURATION FILE ////////////////////
$maxMindAuthCode = "YourMaxMindKey"; // Get it from https://www.maxmind.com/en/my_license_key
///->>>> MYSQL database authentication
$connectserver = "localhost"; 		 // Should be fine as is, unless connecting to a remote server
$connectuser  = "dbuser";		     // MYSQL Username
$connectpass = "dbpass";		     // MYSQL Password
$connectdb = "dbtable";			     // MYSQL Table

// ################# Connect to main db #################
$connMain = mysqli_init();
$connMain->options(MYSQLI_OPT_CONNECT_TIMEOUT, 4);
$connMain->real_connect($connectserver, $connectuser, $connectpass, $connectdb);

	// Get the user ip address
	if ($_SERVER['HTTP_CLIENT_IP']){
	$ipaddress = $_SERVER['HTTP_CLIENT_IP'];
	}
	elseif ($_SERVER['HTTP_X_FORWARDED_FOR']){
	$ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	elseif ($_SERVER['HTTP_X_FORWARDED']){
	$ipaddress = $_SERVER['HTTP_X_FORWARDED'];
	}
	elseif ($_SERVER['HTTP_FORWARDED_FOR']){
	$ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
	}
	elseif ($_SERVER['HTTP_FORWARDED']){
	$ipaddress = $_SERVER['HTTP_FORWARDED'];
	}
	elseif ($_SERVER['REMOTE_ADDR']){
	$ipaddress = $_SERVER['REMOTE_ADDR'];
	}
	else {
	$ipaddress = 'UNKNOWN';
	}
	// Just in case sent as a negative
	if ($ipaddress < 1){
	$ipaddress = "";
	}
	// There is an IP, try to query local db first for a location match
	if ($ipaddress){
	$query = "select id, state, countryCode from geodata where userIp ='$ipaddress' LIMIT 1";
	$result = $connMain->query($query);
	$row = $result->fetch_assoc();
	$ip_id = $row['id'];
	$geo_state = $row['state'];
	$geo_country = $row['countryCode'];

		// This IP has been queried already, just update the hit count
		if ($ip_id){
		// Uncomment this to update IP hits
		//$query = "update geodata set hitCount=hitCount+1 WHERE id ='$ip_id' LIMIT 1";
		//$queryExec = $connMain->query($query);
		}
		// Nothing returned from local db, get it from maxmind
		else{
			// Get the ip geo return data
			function geo_data($theip){
			$params = getopt('l:i:');

			if (!isset($params['l'])) $params['l'] = $maxMindAuthCode;
			$params['i'] = $theip;

			$query = 'https://geoip.maxmind.com/f?' . http_build_query($params);

			$curl = curl_init();
			curl_setopt_array(
				$curl,
				array(
					CURLOPT_URL => $query,
					CURLOPT_USERAGENT => 'MM',
					CURLOPT_RETURNTRANSFER => true
				)
			);

			$resp = curl_exec($curl);

				if (curl_errno($curl)) {
					throw new Exception(
						'GeoIP request failed with a curl_errno of '
						. curl_errno($curl)
					);
				}

			$omni_values = str_getcsv($resp);
			curl_close($curl);
			return $omni_values;
			}

		// Call the geo function and process data
		$geo_dat = geo_data($ipaddress);

			if (is_array($geo_dat)){
				for ($i = 0; $i < count($geo_dat); ++$i) {
				$geo_country = $geo_dat[0];
				$geo_state = $geo_dat[1];
				//$geo_city = $geo_dat[2];
				$geo_org = $geo_dat[3];
				//$u2 = $geo_dat[4];
				//$geo_Lat = $geo_dat[6];
				//$geo_Long = $geo_dat[7];
				$geo_ISP = $geo_dat[8];
				$geo_Org = $geo_dat[9];
				}

				if ($geo_Org==$geo_ISP){
				$geo_ISP = "";
				}
				else{
				$geo_ISP = " | $geo_ISP";
				}

			$org = "$geo_org | $geo_Org$geo_ISP";
			}
			// Store new IP as a db record
			if ($geo_country){
			$geoResults = "$userLogImg <b>$whoisIp</b><br>$userCity$geo_state $geo_country$userISP";
			$geoResultsIns = mysqli_real_escape_string($connMain,$geoResults);
			$query = "insert into geodata (userIp,countryCode,state,org,hitCount) values ('$ipaddress','$geo_country','$geo_state','$org','1')";
			$queryExec = $connMain->query($query);
			}
		}
	}

//mysqli_select_db($connMain, "working-database-if-needed");
//echo "STATE: $geo_state"; // To test this script, uncomment this line
